#!/usr/bin/perl
use Time::Local;
# $Id: iv1.pl,v 1.4 2008/03/06 09:30:52 skoch Exp $
open IVT,  '<', $ARGV[0] or die "Could not open $ARGV[0] $!\n";
open DATA, '<', $ARGV[1] or die "Could not open $ARGV[1] $!\n";
my $str = <DATA>;
my @l = split(/\s+/,$str);
my $utimecol = 0;
for (my $x = 0; $x < @l; $x++)
{
    next unless ($l[$x] =~ /utime/);
    $utimecol = $x+1;
}
$nextline = undef;
if ($ARGV[2])
{
    $tshiftfile .= '/home/http/html/rig'.$ARGV[2].'/'.$ARGV[2].'test'.$ARGV[3].'/timeshift.txt';
    if (-e $tshiftfile)
    {
        open MYIN,'<',$tshiftfile or die;
        $tshift = <MYIN>;
        chomp $tshift;
        $tshift = -3600 * $tshift;
        $nextline = <MYIN>;
    }
}
$ivcount = 0;
$tbuf=1;
while (<IVT>) {
    $ivcount++;
    if ($nextline =~ /^$ivcount\s+([\d\.]+)/)
    {
        $tshift = -$1*3600;
        $nextline = <MYIN>;
    }
    @a  = split ( " ", $_ );
    @t1 = split ( ":", $a[0] );
    $t1[0] -= 1900;
    $t1[1] -= 1;

    @t2 = split ( ":", $a[1] );
    $t2[0] -= 1900;
    $t2[1] -= 1;

    $tl1 = timelocal( reverse(@t1) ) - $tbuf + $tshift;
    $tl2 = timelocal( reverse(@t2) ) + $tbuf + $tshift;
    $d[$utimecol] = 0;
    $cmax=0;
    $cmaxa = 0;
    while ( ( $line = <DATA> ) && ( $d[$utimecol] < $tl1 ) ) {

        @d = split ( " ", $line );

    }
$nstart=$.-1;
$dstart=$d[1];
$tstart=$d[0];
    while ( ( $line = <DATA> ) && ( $d[$utimecol] < $tl2 ) ) {
        @d = split ( " ", $line );
	if ($d[$utimecol] < $tl2 )  {$dstop=$d[1];$tstop=$d[0];};
        if ($#d) {
            for ( $i = 2 ; $i < $#d ; $i += 2 ) {
                $data{ $d[$i] } = $d[ $i + 1 ]; }
                $Time = $d[0];
                $date = $d[1];

            $h2      = $data{'h2'};
            $o2      = $data{'o2'};
            $air     = $data{'air'};
            $ch4     = $data{'ch4'};
            $current = $data{'current'};
            $backup  = $data{'backup'};
            $voltage = $data{'cell_voltage'};
        
	if (abs($current) > $cmaxa) {	#???
	    $cmaxa = abs($current);
	    $cmax = $current;
	    $ncmax = $.;
	    $vcmax = $voltage;
	    $tmax = $Time;
	    $h2max = $h2;
	    $o2max = $o2;
	    $airmax = $air;
	    $ch4max = $ch4;
	    $backupmax = $backup;
	}
}

    }

	print 'dstart'," ", $dstart," ", 'dstop'," ", $dstop," ", 'nstart'," ", $nstart," ", 'ncmax'," ",

	  $ncmax," ", 'nstop'," ", $.-2 ," ", 'tstart'," ", $tstart," ", 'tstop'," ", $tstop," ", 'cmax'," ",

	  $cmax," ", 'Voltage_at_max_current'," ", $vcmax," ", 'H_2'," ", $h2max," ", 'O_2'," ",

	  $o2max," ", 'Air'," ", $airmax," ", 'CH_4'," ", $ch4max," ", 'backup'," ", $backupmax,"\n";

	$cmax = 0;

}
